package ovh.herisson.thevoidroad;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.scoreboard.Criteria;
import org.bukkit.scoreboard.DisplaySlot;
import org.bukkit.scoreboard.Objective;
import org.bukkit.scoreboard.RenderType;
import org.bukkit.scoreboard.Score;
import org.bukkit.scoreboard.Scoreboard;
import org.bukkit.scoreboard.ScoreboardManager;

import net.kyori.adventure.bossbar.BossBar;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.kyori.adventure.title.Title;

public final class Voids implements Listener{

	private static HashMap<Player, BossBar> bossbars = new HashMap<>();

	public static int get(Player ply){
		return TheVoidRoad.db.getVoids(ply.getUniqueId());
	}

	public static void set(Player ply, int amount){
		TheVoidRoad.db.setVoids(ply.getUniqueId(), amount);
		UpdateVoids(ply);
	}

	public static void add(Player ply, int amount){
		int curr = DatabaseManager.getInstance().getVoids(ply.getUniqueId());
		DatabaseManager.getInstance().setVoids(ply.getUniqueId(), curr + amount);
		UpdateVoids(ply);
	} 
	
	public static boolean subtract(Player ply, int amount, boolean force){
		int curr = TheVoidRoad.db.getVoids(ply.getUniqueId());
		if(curr - amount < 0 && !force) return false;
		TheVoidRoad.db.setVoids(ply.getUniqueId(), curr - amount);
		UpdateVoids(ply);
		return true;
	} 

	public static boolean give(Player giver, Player receiver, int amount){
		if(	amount < 0 || !subtract(giver, amount, false))
			return false;
		add(receiver, amount);
		giver.sendMessage("Vous avez donné " + amount + TheVoidRoad.CoinGlyph + " à " + receiver.getName());
		receiver.sendMessage("Vous avez reçu " + amount + TheVoidRoad.CoinGlyph + " de " + giver.getName());
		receiver.showTitle(Title.title(Component.empty(), Component.text("+" + amount + TheVoidRoad.CoinGlyph + " from " + giver.getName()).color(NamedTextColor.GREEN)));
		return true;
	}

	public static HashMap<Player, Integer> scoreboard(){
		HashMap<Player, Integer> ret = new HashMap<>();
		try {
			HashMap<UUID, Integer> scores_uuid = TheVoidRoad.db.getVoidsScoreboard();
			scores_uuid.forEach((u, a) -> {
				ret.put(Bukkit.getPlayer(u), a);
			});
		} catch(SQLException e){
			e.printStackTrace();
		}
		return ret;
	}

	public static void UpdateVoids(Player ply){
		Integer count = get(ply);
		String countString = count.toString() + TheVoidRoad.CoinGlyph;

		Scoreboard sb = Bukkit.getScoreboardManager().getMainScoreboard();
		Objective o = sb.getObjective("VOIDS") != null ? sb.getObjective("VOIDS") : sb.registerNewObjective("VOIDS", Criteria.DUMMY, "voids");
		o.setDisplaySlot(DisplaySlot.BELOW_NAME);
		o.displayName(Component.text(TheVoidRoad.CoinGlyph));
		Score s = o.getScore(ply);
		s.setScore(count);

		BossBar bb = bossbars.containsKey(ply) ?
		   	bossbars.get(ply).name(Component.text(countString)) :
		   	BossBar.bossBar(Component.text(countString), 1, BossBar.Color.GREEN, BossBar.Overlay.PROGRESS);

		bossbars.put(ply, bb);
		ply.showBossBar(bb);
	}

	@EventHandler
	public void UpdateVoids(PlayerJoinEvent e){
		UpdateVoids(e.getPlayer());
	}
}
